<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Menu/MenuItem.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li><li class="navelem"><a class="el" href="dir_325a9a77de343a5b727763275460672d.html">Menu</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">MenuItem.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_menu_item_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;{</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">class </span>MenuItem</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">enum</span> MenuType</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            <span class="comment">// Fight action</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            Pass,</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            Move,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            Fight,</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;            <span class="comment">//For the fight</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;            MoveLeft,</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            MoveRight,</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            MoveTo,</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            FightObject,</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            FightSpell,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="comment">//Other</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            Interact,</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;            Percreption,</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            Cancel,</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            CharacterSelection,</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            Default,</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        };</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keywordtype">char</span> m_key{<span class="charliteral">&#39;-&#39;</span>};</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordtype">string</span> m_text{<span class="stringliteral">&quot;unnamed menu&quot;</span>};</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        MenuType m_type{Default};</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        shared_ptr&lt;void&gt; m_linkedElement{<span class="keyword">nullptr</span>};</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        MenuItem(<span class="keywordtype">string</span> text, MenuType type, shared_ptr&lt;void&gt; linkedElement = <span class="keyword">nullptr</span>, <span class="keywordtype">char</span> key = <span class="charliteral">&#39;-&#39;</span>);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">virtual</span> ~MenuItem() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordtype">string</span> GetTextMenuItem() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordtype">bool</span> IsThisMenuSelected(<span class="keywordtype">char</span> key) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">void</span> SetKey(<span class="keywordtype">char</span> key);</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        MenuType GetMenuType() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        shared_ptr&lt;void&gt; GetLinkedElement() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    };</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
